package miniteller;
abstract public class _MiniTellerImplBase extends org.omg.CORBA.portable.Skeleton implements MiniTeller {
  protected MiniTeller _wrapper = null;
  public MiniTeller _this() {
    return this;
  }
  protected _MiniTellerImplBase(String name) {
    super(name);
  }
  public _MiniTellerImplBase() {
  }
  public String[] _ids() {
    return __ids;
  }
  private static String[] __ids = {
    "IDL:miniteller/MiniTeller:1.0"
  };
  public org.omg.CORBA.portable.MethodPointer[] _methods() {
    org.omg.CORBA.portable.MethodPointer[] methods = {
      new org.omg.CORBA.portable.MethodPointer("getAccounts", 0, 0),
      new org.omg.CORBA.portable.MethodPointer("getAccount", 0, 1),
      new org.omg.CORBA.portable.MethodPointer("newAccount", 0, 2),
    };
    return methods;
  }
  public boolean _execute(org.omg.CORBA.portable.MethodPointer method, org.omg.CORBA.portable.InputStream input, org.omg.CORBA.portable.OutputStream output) {
    switch(method.interface_id) {
    case 0: {
      return _MiniTellerImplBase._execute(_this(), method.method_id, input, output); 
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
  public static boolean _execute(MiniTeller _self, int _method_id, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.OutputStream _output) {
    switch(_method_id) {
    case 0: {
      try {
        Account[] _result = _self.getAccounts();
        AccountSeqHelper.write(_output, _result);
      }
      catch(AccessViolation _exception) {
        AccessViolationHelper.write(_output, _exception);
        return true;
      }
      return false;
    }
    case 1: {
      try {
        int acctno;
        acctno = _input.read_long();
        Account _result = _self.getAccount(acctno);
        AccountHelper.write(_output, _result);
      }
      catch(AccessViolation _exception) {
        AccessViolationHelper.write(_output, _exception);
        return true;
      }
      return false;
    }
    case 2: {
      try {
        float openBal;
        openBal = _input.read_float();
        Account _result = _self.newAccount(openBal);
        AccountHelper.write(_output, _result);
      }
      catch(AccessViolation _exception) {
        AccessViolationHelper.write(_output, _exception);
        return true;
      }
      catch(DataInvalid _exception) {
        DataInvalidHelper.write(_output, _exception);
        return true;
      }
      return false;
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
}
