package miniteller;

import java.util.Hashtable;
import java.util.Enumeration;
import java.sql.ResultSet;

public class AccountList extends Hashtable {
  public void addAccount(Account e) {
    put(new Integer(e.acctno()), e);
  }
  public Account getAccount(int acctno) {
    return (Account) get(new Integer(acctno));
  }
  public boolean deleteAccount(int acctno) {
    Object o = remove(new Integer(acctno));
    if (o == null) return false; // not in table
    return true; // successful deletion
  }
  public void copyInto(Account[] a) {
    int i = 0;
    for (Enumeration e = elements() ; e.hasMoreElements() ; i++) {
      a[i] = (Account) e.nextElement();
    }
  }
}
