package miniteller;
public interface Account extends org.omg.CORBA.Object {
  final public static short bidx_acct = (short)0;
  final public static short bidx_name = (short)1;
  final public static short bidx_bal = (short)2;
  final public static short cidx_first = (short)0;
  final public static short cidx_last = (short)1;
  final public static short cidx_addr1 = (short)2;
  final public static short cidx_addr2 = (short)3;
  final public static short cidx_phone = (short)4;
  final public static short cidx_ssn = (short)5;
  public int acctno();
  public String[] getBasicInfo() throws AccessViolation;
  public float getBalance() throws AccessViolation;
  public float deposit(float amt) throws DataInvalid, AccessViolation;
  public float withdraw(float amt) throws DataInvalid, AccessViolation, InsufficientFunds;
  public float transfer(float amt, Account dest, org.omg.CORBA.FloatHolder destbal) throws DataInvalid, AccessViolation, InsufficientFunds;
  public String[] getCustomerInfo() throws AccessViolation;
  public void setCustomerInfo(String firstName, String lastName, String addr1, String addr2, String phone, String ssn) throws DataInvalid, AccessViolation;
}
